Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgrapht.graph
Class UnmodifiableGraph<V,E>

    java.lang.Object
      org.jgrapht.graph.AbstractGraph<V,E>
          org.jgrapht.graph.GraphDelegator<V,E>
              org.jgrapht.graph.UnmodifiableGraph<V,E>

All Implemented Interfaces:
  java.io.Serializable, Graph<V,E>

Direct Known Subclasses:
  UnmodifiableDirectedGraph, UnmodifiableUndirectedGraph

    public class UnmodifiableGraph<V,E>

extends GraphDelegator<V,E>
implements java.io.Serializable

An unmodifiable view of the backing graph specified in the constructor. This graph allows modules to provide users with "read-only" access to internal graphs. Query operations on this graph "read through" to the backing graph, and attempts to modify this graph result in an `UnsupportedOperationException`.

This graph does not pass the hashCode and equals operations through to the backing graph, but relies on `Object`'s `equals` and `hashCode` methods. This graph will be serializable if the backing graph is serializable.

Since:
  Jul 24, 2003
Author:
  Barak Naveh
See Also:
  Serialized Form

Constructor Summary
`UnmodifiableGraph(Graph<V,E> g)` Creates a new unmodifiable graph based on the specified backing graph.

Method Summary
`E` | `addEdge(V sourceVertex, V targetVertex)` Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge.
`boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Adds the specified edge to this graph, going from the source vertex to the target vertex.
`boolean` | `addVertex(V v)` Adds the specified vertex to this graph if not already present.
`boolean` | `removeAllEdges(java.util.Collection<? extends E> edges)` Removes all the edges in this graph that are also contained in the specified edge collection.
`java.util.Set<E>` | `removeAllEdges(V sourceVertex, V targetVertex)` Removes all the edges going from the specified source vertex to the specified target vertex, and returns a set of all removed edges.
`boolean` | `removeAllVertices(java.util.Collection<? extends V> vertices)` Removes all the vertices in this graph that are also contained in the specified vertex collection.
`boolean` | `removeEdge(E e)` Removes the specified edge from the graph.
`E` | `removeEdge(V sourceVertex, V targetVertex)` Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph.
`boolean` | `removeVertex(V v)` Removes the specified vertex from this graph including all its touching edges if present.

Methods inherited from class org.jgrapht.graph.GraphDelegator
`containsEdge, containsVertex, degreeOf, edgeSet, edgesOf, getAllEdges, getEdge, getEdgeFactory, getEdgeSource, getEdgeTarget, getEdgeWeight, incomingEdgesOf, inDegreeOf, outDegreeOf, outgoingEdgesOf, setEdgeWeight, toString, vertexSet`

Methods inherited from class org.jgrapht.graph.AbstractGraph
`assertVertexExist, containsEdge, removeAllEdges, toStringFromSets`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.jgrapht.Graph
`containsEdge`

Constructor Detail

### UnmodifiableGraph

    public UnmodifiableGraph(Graph<V,E> g)

  Creates a new unmodifiable graph based on the specified backing graph.

  Parameters:
    `g` - the backing graph on which an unmodifiable graph is to be created.

Method Detail

### addEdge

    public E addEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `null`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  This method creates the new edge `e` using this graph's `EdgeFactory`. For the new edge to be added `e` must not be equal to any other edge the graph (even if the graph allows edge-multiplicity). More formally, the graph must not contain any edge `e2` such that `e2.equals(e)`. If such `e2` is found then the newly created edge `e` is abandoned, the method leaves this graph unchanged returns `null`.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The newly created edge if added to the graph, otherwise `null`.
  See Also:
    `Graph.addEdge(Object, Object)`

### addEdge

    public boolean addEdge(V sourceVertex,
                           V targetVertex,
                           E e)

  Description copied from interface: `Graph`
  Adds the specified edge to this graph, going from the source vertex to the target vertex. More formally, adds the specified edge, `e`, to this graph if this graph contains no edge `e2` such that `e2.equals(e)`. If this graph already contains such an edge, the call leaves this graph unchanged and returns `false`. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `false`. If the edge was added to the graph, returns `true`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Overrides:
    `addEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
    `e` - edge to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified edge.
  See Also:
    `Graph.addEdge(Object, Object, Object)`

### addVertex

    public boolean addVertex(V v)

  Description copied from interface: `Graph`
  Adds the specified vertex to this graph if not already present. More formally, adds the specified vertex, `v`, to this graph if this graph contains no vertex `u` such that `u.equals(v)`. If this graph already contains such vertex, the call leaves this graph unchanged and returns `false`. In combination with the restriction on constructors, this ensures that graphs never contain duplicate vertices.

  Specified by:
    `addVertex` in interface `Graph<V,E>`
  Overrides:
    `addVertex` in class `GraphDelegator<V,E>`
  Parameters:
    `v` - vertex to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified vertex.
  See Also:
    `Graph.addVertex(Object)`

### removeAllEdges

    public boolean removeAllEdges(java.util.Collection<? extends E> edges)

  Description copied from interface: `Graph`
  Removes all the edges in this graph that are also contained in the specified edge collection. After this call returns, this graph will contain no edges in common with the specified edges. This method will invoke the `Graph.removeEdge(Object)` method.

  Specified by:
    `removeAllEdges` in interface `Graph<V,E>`
  Overrides:
    `removeAllEdges` in class `AbstractGraph<V,E>`
  Parameters:
    `edges` - edges to be removed from this graph.
  Returns:
    `true` if this graph changed as a result of the call
  See Also:
    `Graph.removeAllEdges(Collection)`

### removeAllEdges

    public java.util.Set<E> removeAllEdges(V sourceVertex,
                                           V targetVertex)

  Description copied from interface: `Graph`
  Removes all the edges going from the specified source vertex to the specified target vertex, and returns a set of all removed edges. Returns `null` if any of the specified vertices does not exist in the graph. If both vertices exist but no edge is found, returns an empty set. This method will either invoke the `Graph.removeEdge(Object)` method, or the `Graph.removeEdge(Object, Object)` method.

  Specified by:
    `removeAllEdges` in interface `Graph<V,E>`
  Overrides:
    `removeAllEdges` in class `AbstractGraph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    the removed edges, or `null` if no either vertex not part of graph
  See Also:
    `Graph.removeAllEdges(Object, Object)`

### removeAllVertices

    public boolean removeAllVertices(java.util.Collection<? extends V> vertices)

  Description copied from interface: `Graph`
  Removes all the vertices in this graph that are also contained in the specified vertex collection. After this call returns, this graph will contain no vertices in common with the specified vertices. This method will invoke the `Graph.removeVertex(Object)` method.

  Specified by:
    `removeAllVertices` in interface `Graph<V,E>`
  Overrides:
    `removeAllVertices` in class `AbstractGraph<V,E>`
  Parameters:
    `vertices` - vertices to be removed from this graph.
  Returns:
    `true` if this graph changed as a result of the call
  See Also:
    `Graph.removeAllVertices(Collection)`

### removeEdge

    public boolean removeEdge(E e)

  Description copied from interface: `Graph`
  Removes the specified edge from the graph. Removes the specified edge from this graph if it is present. More formally, removes an edge `e2` such that `e2.equals(e)`, if the graph contains such edge. Returns `true` if the graph contained the specified edge. (The graph will not contain the specified edge once the call returns).

  If the specified edge is `null` returns `false`.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Overrides:
    `removeEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `e` - edge to be removed from this graph, if present.
  Returns:
    `true` if and only if the graph contained the specified edge.
  See Also:
    `Graph.removeEdge(Object)`

### removeEdge

    public E removeEdge(V sourceVertex,
                        V targetVertex)

  Description copied from interface: `Graph`
  Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph. Returns the edge if removed or `null` otherwise.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Overrides:
    `removeEdge` in class `GraphDelegator<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The removed edge, or `null` if no edge removed.
  See Also:
    `Graph.removeEdge(Object, Object)`

### removeVertex

    public boolean removeVertex(V v)

  Description copied from interface: `Graph`
  Removes the specified vertex from this graph including all its touching edges if present. More formally, if the graph contains a vertex `u` such that `u.equals(v)`, the call removes all edges that touch `u` and then removes `u` itself. If no such `u` is found, the call leaves the graph unchanged. Returns `true` if the graph contained the specified vertex. (The graph will not contain the specified vertex once the call returns).

  If the specified vertex is `null` returns `false`.

  Specified by:
    `removeVertex` in interface `Graph<V,E>`
  Overrides:
    `removeVertex` in class `GraphDelegator<V,E>`
  Parameters:
    `v` - vertex to be removed from this graph, if present.
  Returns:
    `true` if the graph contained the specified vertex; `false` otherwise.
  See Also:
    `Graph.removeVertex(Object)`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD